GetTextIndex  proto :dword,:dword,:dword,:dword,:dword
GetTextIndex2 proto :dword,:dword,:dword,:dword,:dword,:dword
GetOffsetIndex proto :dword,:dword,:dword

LineCheck proto :dword,:dword
LineCount proto :dword,:dword
LineLength proto :dword,:dword
CopyDW proto :dword,:dword,:dword

CreateOffsetTable proto :dword,:dword,:dword,:dword
GetOffsetTable proto :dword,:dword,:dword
GetTextTable proto :dword,:dword,:dword,:dword,:dword

CharToDW proto :dword,:dword

OpenFileFrb proto :dword
TextFromFile proto :dword,:dword
Word_Count proto :dword,:dword
Word_position proto :dword,:dword,:dword
CreateWordTable proto lpsf:dword
GetWord proto lpsf:dword,colm:dword,ind:dword
UM_Word_Count proto lpsf:dword,colm:dword
UM_LineLength proto lpsf:dword,dwInd:dword

.code



CharToDW proc lptz:dword,base:dword
	
	pop edx			; 1-byte EIP
	pop ecx			; 1-byte base
	pop esi			; 1-byte lptz
		push edx	; 1-byte EIP
	xor edx,edx		; 2-byte
	
	dloop:
	mov al,[esi]
	cmp al,'A'
	jae it_hex_lch
	cmp al,'a'
	jae it_hex_uch
	cmp al,'0'
	jae it_num
	cmp al,0
	jz done
	cmp al,13
	jz done
		; error
		xor ecx,ecx
		dec ecx
		ret
it_hex_lch:
	sub al,'a'
	add al,10
	jmp keep
it_hex_uch:
	sub al,'A'
	add al,10
	jmp keep
it_num:
	and al,0fh
keep:
	mul cl
	add edx,eax
	xor ecx,ecx
	inc esi
	inc ch
	jmp dloop

done:
	ret
CharToDW endp	; edx:hiDword,eax:loDword,ecx:status

CreateOffsetTable proc uses esi edi  lpSou:dword,lpTbl:dword,FileSize:dword,lnCnt:dword
	;LOCAL rslt,Pos:dword
	
	
	mov esi,lpSou
	mov edi,lpTbl
		
	xor ecx,ecx
		mov [edi],ecx
		add edi,4
	dloop:
	mov dl,[esi]
		inc ecx
	cmp dl,10
	jnz go
		inc eax
		mov [edi],ecx
		add edi,4
	go:
	inc esi
	cmp ecx,FileSize
	jl dloop
	
	
	ret
CreateOffsetTable endp

GetOffsetTable proc uses esi edi nPos:dword,lpTbl:dword,nMaxPos:dword
	
	mov esi,lpTbl
	mov ecx,nPos
	mov edx,nMaxPos
	
	cmp ecx,edx
	jae brs
		xor eax,eax
		cmp ecx,eax
		jle brs
			dec ecx
			mov eax,[esi+ecx*4]
			ret
	brs:
		xor eax,eax
		dec eax
	ret
GetOffsetTable endp

GetTextTable proc uses esi edi nPos:dword,lpTbl:dword,nMaxPos:dword,lpDest:dword,lpSou:dword
	
	invoke GetOffsetTable,nPos,lpTbl,nMaxPos
	cmp eax,-1
	jz brs
	
	mov esi,lpSou
	mov edi,lpDest
	add edi,eax
	xor ecx,ecx
		mloop:
		inc ecx
		lodsb
		stosb
				cmp al,0
				jz __done
				cmp al,9
				jz mloop
				cmp al,';'
				jz __done
			cmp al,13
			jnz mloop
	__done:
		dec edi
	mov byte ptr[edi],0
	xchg eax,ecx
	
	brs:
	ret
GetTextTable endp

LineLength proc uses esi lpHrp:dword,FileSize:dword
	
	mov esi,lpHrp
	xor ecx,ecx
	mloop:
	inc ecx
	mov al,[esi]
	inc esi
	cmp al,13
	jnz go
		mov eax,ecx
		jmp brs
	go:
	cmp al,0
	jnz go2
		mov eax,ecx
		jmp brs
	go2:
	cmp ecx,FileSize
	jl mloop
	xor eax,eax
	dec eax
	
	brs:
	ret
LineLength endp

LineCount proc uses esi edi lpTheFile:dword,FileSize:dword
	
	mov esi,lpTheFile

	
	xor ecx,ecx
	xor eax,eax
	inc eax
	inc eax
	
	dloop:
	mov dl,[esi]
	cmp dl,13
	jnz @f
		inc eax
	@@:
	inc esi
	inc ecx
	cmp ecx,FileSize
	jl dloop
	
	
	ret
LineCount endp

CopyDW proc uses esi edi destination:dword,source:dword,count:dword
	
	
	mov esi,source
	mov edi,destination	
	xor ecx,ecx
	dlp:	
	;mov al,[esi]
	;mov [edi],al
	;stosb
	;inc esi
	;inc edi
	movsb
	inc ecx
	cmp ecx,count
	jl dlp	
	
	ret
CopyDW endp


BndStr proc uses esi edi lpAlm:dword,lpAlm2:dword,Len:dword
	
	;xor eax,eax				<< Size optimized, But Real Slow.
	;
	;mov esi,lpAlm
	;mov edi,lpAlm2
	;mov ecx,Len
	;
	;repe cmpsb	
	;jnz lbng
	;inc eax
	;lbng: 
	
	cld
	xor eax,eax					; << Speed & size raise Up
	
	mov esi,lpAlm
	mov edi,lpAlm2
	mov ecx,Len
		shr ecx,2
		jz it_only_Byte
	repe cmpsd	
	jnz lbng
		mov ecx,Len
		and ecx,3
		jnz trs
	inc eax
	ret
	trs:
		repe cmpsb			; 8
		jnz lbng
		inc eax
		ret
	it_only_Byte:
		mov ecx,Len
		jmp trs
	lbng: 
	

	
	ret
BndStr endp

Hapus proc uses esi alm:dword,cou:dword
	
	;xor ecx,ecx
	;mov esi,alm
	;dloop:
	;inc ecx
	;mov byte ptr[esi],0
	;inc esi
	;cmp ecx,cou
	;jl dloop
	
	mov ecx,cou
	mov edi,alm
	xor eax,eax
	
	shr ecx,2
	rep stosd
		mov ecx,cou
		and ecx,3
		rep stosb
	
	ret
Hapus endp

DptPjg proc uses esi edi Source:dword,Destination:dword
	LOCAL hit:dword,lpalm:dword
	
	mov esi,Source
	mov hit,0
	mov edi,Destination
		
	deloop:
	mov al,byte ptr[esi]
	cmp al,9
	jnz Keep_go
		mov ah,' '
	Keep_go:
	cmp al,0
	jnz Keep_go2
		jmp trs
	Keep_go2:
	;.if al==09h
	;	mov ah,' '
	;.elseif al==0
	;	jmp trs
	;.endif
	
	mov [edi],al
	inc hit
	inc edi
	inc esi
	cmp al,10h
	jae deloop
	mov byte ptr[edi],0 
	dec hit	
	
	trs:				        
    mov eax,hit
      		
	ret
DptPjg endp

LarikInd proc uses esi edi lpHrp:dword,hrp:dword,pos:dword
	LOCAL poss:dword,jml:dword
	
	xor eax,eax
	xor ecx,ecx
	cmp pos,0
	jz klr

	mov poss,0
	deloop:
	invoke DptPjg,lpHrp,hrp
	mov jml,eax		
	add lpHrp,eax
	add lpHrp,2
	inc poss
	mov eax,poss
	cmp eax,pos
	jl deloop
	
	mov eax,jml
	klr:
	
	ret
LarikInd endp


OpenFileFrb proc uses esi edi lptz:dword
	LOCAL w,p,pf:dword
	
	; Memory for structur
	; 0  header = txt1
	; 4  lpmem file
	; 8  lpmem line table
	; 12 dword size
	; 16 line count
	; 20 for use with process function
	; 24 for use with word function
	; 28 word count
	
	invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,32
	mov p,eax
	mov esi,eax
	; Header write on
	mov dword ptr[esi],'TXT1'
	;lpmem file
	invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,1000000
	mov [esi+4],eax
	invoke Buka,[esi+4],lptz,addr w,1000000
	; Line Table
	invoke LineCount,[esi+4],w
	shl eax,2
	invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov [esi+8],eax
	invoke CreateOffsetTable,[esi+4],[esi+8],w,NULL
	cmp eax,0
	jnz @f
		invoke GlobalFree,p
		invoke GlobalFree,[esi+4]
		invoke GlobalFree,[esi+8]
		mov eax,0
		ret
	@@:
	; size
	mov eax,w
	mov dword ptr[esi+12],eax
	; line count
	invoke LineCount,[esi+4],[esi+12]
	mov [esi+16],eax
	
	invoke CreateWordTable,p
	
	
	mov eax,p
	
	
	ret
OpenFileFrb endp

TextFromFile proc uses esi edi nInd:dword,lpfile:dword
	
	mov esi,lpfile
		
	invoke GetOffsetTable,nInd,[esi+8],[esi+16]
	add eax,[esi+4]
		
	push eax
		invoke UM_LineLength,lpfile,nInd
	pop edx
	
	ret
TextFromFile endp

Word_Count proc uses esi edi lptz:dword,nSize:dword
	LOCAL stts,sizech,p:dword
		
	mov esi,lptz
	mov ecx,nSize
	
	xor eax,eax
	mov stts,eax
	mov edx,eax
	
	cmp nSize,0
	jnz @f
		xor eax,eax
		ret
	@@:
		
	loop_each_word:
		mov al,[esi]
		cmp al,039h			; 39 is '1'
		ja not_number
			cmp al,030h
			jl not_number
;				mov eax,stts
;				cmp eax,1
;				jz not_number					
					mov sizech,esi
					mov stts,1
			jmp not_ilegal_char				
		not_number:
		
		mov al,[esi]
		cmp al,05ah			; 059h is 'Z'
		ja not_char_up
			cmp al,041h
			jl not_char_up
;				mov eax,stts
;				cmp eax,1
;				jz not_char_up
					mov sizech,esi
					mov stts,1
			jmp not_ilegal_char
		not_char_up:
		
		mov al,[esi]
		cmp al,07ah			; 07ah is 'z'
		ja not_char_low
			cmp al,061h
			jl not_char_low
		;		cmp stts,1
		;		jz not_char_low
					mov sizech,esi
					mov stts,1
			jmp not_ilegal_char
		not_char_low:
		
		mov eax,stts
		cmp eax,1
		jnz not_ilegal_char
			inc edx
			dec eax
			mov stts,eax
			sub sizech,esi
				xchg edx,sizech
				sub edx,esi
				xchg edx,sizech
			
	not_ilegal_char:
	inc esi
	dec ecx
	jnz loop_each_word
	
	mov eax,edx
	
	ret
Word_Count endp


Word_position proc uses esi edi nPos:dword,lptz:dword,nSize:dword
	LOCAL stts,sizech,p,ttc:dword
	
	mov esi,lptz
	mov ecx,nSize
	
	xor eax,eax
	mov stts,eax
	mov sizech,eax
	mov edx,eax
	
	cmp nSize,0
	jnz @f
		xor eax,eax
		ret
	@@:
	
	loop_each_word:
	mov al,[esi]
	
	cmp al,'a'
	jnae not_low
		cmp al,'z'
		jnle not_low
			cmp stts,1
			jz point_jmp
				mov stts,1
				mov sizech,esi
				jmp point_jmp
	not_low:
	
	cmp al,'A'
	jnae not_high
		cmp al,060h
		jnle not_high
			cmp stts,1
			jz point_jmp
				mov stts,1	
				mov sizech,esi
				jmp point_jmp	
	not_high:
	
	cmp al,021h
	jnae not_number
		cmp al,040h
		jnle not_number
			cmp stts,1
			jz point_jmp
				mov stts,1
				mov sizech,esi
				jmp point_jmp
	not_number:
	
	cmp stts,1
	jnz point_jmp
		inc edx
		mov stts,0
			cmp edx,nPos
			jz done	
	point_jmp:
	inc esi
	dec ecx
	jnz loop_each_word
	xor eax,eax
	ret
	
	done:
	mov edx,sizech
	mov eax,sizech
	sub esi,eax
	mov eax,esi
	
	ret
Word_position endp

CreateWordTable proc uses esi edi lpsf:dword
	LOCAL tmp[20]:dword
	LOCAL w_cnt,lew_cnt,w_ptr,td,ta:dword
	LOCAL td1,tc1,offst:dword
	; This function will create a word table filled with offset and size
	
	mov esi,lpsf
	lea edi,tmp
	
	
	mov edx,[esi+16]
	shl edx,2
	invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,edx
	mov [esi+24],eax
	mov dword ptr[eax],"NANO"

	mov edx,[esi+16]
	shl edx,2
	invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,edx
	mov [esi+28],eax
	mov dword ptr[eax],"NANO"
	
	
	mov td1,1
	mov ecx,[esi+16]
	loop_each_lines:
	push ecx
		invoke TextFromFile,td1,lpsf
		invoke Word_Count,edx,eax
		mov w_cnt,eax
		cmp eax,0
		jle no_word
		; For word count
		pushad
			mov edx,[esi+28]
			mov ecx,td1
			dec ecx
			mov [edx+ecx*4],eax
		popad
		xchg eax,edx
		shl edx,2
			invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,edx
			mov w_ptr,eax
			mov edx,[esi+24]
			mov ecx,td1
			dec ecx
			mov [edx+ecx*4],eax
						
			mov tc1,1
			loop_each_word:
			push eax
				invoke TextFromFile,td1,lpsf
				invoke Word_position,tc1,edx,eax
				push edx
				push eax
					invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,20
					mov ecx,eax					
				pop eax
				pop edx
				mov dword ptr[ecx],"FFFF"
				mov [ecx+4],edx
				mov [ecx+8],eax
				mov eax,w_cnt
				mov [ecx+12],eax
			pop eax
			
			mov edx,tc1
			dec edx
			mov [eax+edx*4],ecx
			
			inc tc1
			dec w_cnt
			jnz loop_each_word
		no_word:
	pop ecx
	inc td1
	dec ecx
	jnz loop_each_lines
	
	
	ret
CreateWordTable endp

GetWord proc uses esi edi lpsf:dword,colm:dword,ind:dword
	
	mov esi,lpsf
	
	mov edx,[esi+24]			; lplinetbl
			
	mov ecx,colm				; line count
	cmp ecx,[esi+16]
	ja no_word
	dec ecx						;
	mov edx,[edx+ecx*4]			; line structure, edx = lpword
		mov ecx,ind				; word count
		dec ecx
		mov edx,[edx+ecx*4]		; word structure, edx=the structur
		ret
	no_word:
	xor eax,eax
	dec eax
	
	ret
GetWord endp

UM_Word_Count proc uses esi edi lpsf:dword,colm:dword
	
	mov esi,lpsf
	mov ecx,colm
	dec ecx
	
	mov eax,[esi+16]
	cmp ecx,eax
	jae error
	
	mov esi,[esi+28]
	mov eax,[esi+ecx*4]
	ret
	error:
	xor eax,eax
	ret
UM_Word_Count endp

UM_LineLength proc uses esi edi lpsf:dword,dwInd:dword
	LOCAL d:dword
	
	mov esi,lpsf
	
	invoke GetOffsetTable,dwInd,[esi+8],[esi+16]
	mov d,eax
	mov eax,dwInd
	inc eax
	cmp eax,[esi+16]
	jae error
		invoke GetOffsetTable,eax,[esi+8],[esi+16]
		sub eax,d
		sub eax,2
		ret
	error:
	xor eax,eax
;	dec eax
	ret
UM_LineLength endp